/*
 <applet code="GameApplet" height=500 width=800>
 </applet>

 Copyright (C) 2005 Nitin Diwaker

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License,or  any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

A copy of GNU GPL is enclosed in the package,in which this file is enclosed under the name "LICENSE".You may also view an online copy at:
		http://opensource.org/licenses/gpl-license.php

Author: Nitin Diwaker
58,Talabpura
Lalitpur(UP) -284403
India

nitinatindore@rediffmail.com
diwakernitin@yahoo.co.in
http://www.geocities.com/diwakernitin
*/

/* GameApplet.java
This program is a part of the software "homemade dictionary ver2.0*/


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.ArrayList;
import java.io.*;
import java.util.Random;
import java.net.*;
import java.applet.AudioClip;

public class GameApplet extends JApplet implements ActionListener
    {
    JTextField northTF;
    ButtonGroup cbg;
    JRadioButton ans[];
    JButton Submit,Next, StopMusic;
    boolean music_on=true;
    JLabel Status;
    JLabel Score;
    AudioClip clip;
    Random r; ////random word index,r stores location where ans shall be placed
    URL                url;
	URLConnection      urlConn;
    DataInputStream    dis;
    String word,meaning;
    ArrayList arr;
    int wc=0; //wordcount
    int index=0;
    int ansloc=0;
    static int i=0,pos=0;
    int score=0;
    JRadioButton jrb;
    Color orig;

    public void init()
    {
		arr=new ArrayList(11000);

		try
		{
			URL url;
			URLConnection urlConn;
    		DataInputStream dis;

			url = new URL(getCodeBase().toString() + "words.txt");
			urlConn = url.openConnection();
			urlConn.setDoInput(true);
			urlConn.setUseCaches(false);
			dis = new DataInputStream(urlConn.getInputStream());
			String s;
			while ((s = dis.readLine()) != null)
			{
			      pos=s.indexOf('#');
			      arr.add(s.substring(0,pos-1));
			      arr.add(s.substring(pos+1,s.length()));
			      ++wc;
			}
			    dis.close();
		}
		catch (Exception e)
		{
			JOptionPane.showMessageDialog(this,"URL Exception");
			System.exit(0);
		}


        r= new Random();

        getContentPane().setFont(new Font("Helvetica", Font.PLAIN, 12));
        getContentPane().setLayout(null);

        northTF = new JTextField("");
        northTF.setEditable(false);
        northTF.setBackground(Color.white);
        northTF.setForeground(Color.orange);
        northTF.setFont(new Font("Times",Font.BOLD,14));
        northTF.setHorizontalAlignment(JTextField.CENTER);
        northTF.setBounds(50,32,700,32);
        getContentPane().add(northTF);

        Status = new JLabel("");
        Status.setBounds(80,100,200,24);
        getContentPane().add(Status);
        Status.setFont(new Font("Serif",Font.BOLD|Font.ITALIC,18));

        cbg = new ButtonGroup();
        ans=new JRadioButton[5];

        for(int i=0;i<5;++i)
        {
        ans[i] = new JRadioButton("hi",false);
        cbg.add(ans[i]);
        getContentPane().add(ans[i]);
        }

        ans[0].setSelected(true);
        orig=ans[0].getBackground();

        ans[0].setBounds(80,136,600,24);
        ans[1].setBounds(80,172,600,24);
        ans[2].setBounds(80,208,600,24);
        ans[3].setBounds(80,244,600,24);
        ans[4].setBounds(80,280,600,24);

        clip = getAudioClip(getCodeBase(),"sound4.mid");
		clip.loop();

        Submit = new JButton("Submit");
        Submit.addActionListener(this);
        Submit.setBounds(180,350,104,24);
        getContentPane().add(Submit);

        Next = new JButton("Next Word");
        Next.setBounds(360,350,104,24);
        getContentPane().add(Next);
        Next.setEnabled(false);
        Next.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent ae )
                {
                    Submit.setEnabled(true);
                    Next.setEnabled(false);
                    generate();
                }
            });

		StopMusic = new JButton("Stop Music");
		StopMusic.setBounds(540,350,104,24);
        getContentPane().add(StopMusic);
        StopMusic.addActionListener(new ActionListener()
		            {
		                public void actionPerformed(ActionEvent ae2 )
		                {
		                    if(music_on)
		                    {
								clip.stop();
			          			StopMusic.setText("Start Music");
			          			music_on=false;
							}
							else
							{
								clip.loop();
			         			StopMusic.setText("Stop Music");
			          			music_on=true;
							}
					}
            });

        Score = new JLabel("Score: 0");
        Score.setBounds(25,400,230,36);
        Score.setFont(new Font("Serif",Font.BOLD|Font.ITALIC,20));
        Score.setForeground(Color.blue);
        getContentPane().add(Score);

        JOptionPane.showMessageDialog(this,"The author takes no reponsiblity whatsoever\n of the correctness of words and their meaning \n Suggestion/feedback is most welcome.\n\nVisit me at: http://www.geocities.com/diwakernitin\n OR mail at nitinatindore@rediffmail.com");

        String s=new String("Test your Word Power\n\n");
        s += "\nInstructions:\n1. Each correct answer carries 20 points"
          + "\n2. Each incorrect answer carries -5 points"
          + "\n3. No. of words: " + String.valueOf(wc)
          + "\n4. No of words displayed is total words in the dictionary that you selected"
          + "\n5. Your score is displayed in bottom left corner of the screen"
          + "\n\n Rest is all simple ! Best Of Luck !!\nPress OK to begin";
        JOptionPane.showMessageDialog(this,s );
        generate();
    }

    public void actionPerformed(ActionEvent ae)  //submit presssed
    {
        Submit.setEnabled(false);
        Next.setEnabled(true);
        for(i=0;i<5;++i)
        {
            if(ans[i].isSelected())
            {
                jrb=ans[i];
                break;
            }
        }

        if(jrb.getText().equals(meaning))
        {
            jrb.setBackground(Color.green);
            Status.setForeground(Color.green);
            Status.setText("Correct Answer");
            score+=20;
            Score.setText("Score : " + String.valueOf(score));
        }
        else
        {
            jrb.setBackground(Color.pink);
            Status.setForeground(Color.red);
            Status.setText("Wrong Answer");
            score -=5;
            Score.setText("Score : " + String.valueOf(score));
        }

        for(i=0;i<5;++i)
        {
            if(ans[i].getText().equals(meaning))
                ans[i].setBackground(Color.green);
        }

        Next.requestFocus();
    }

    public void generate()
    {
        //reset background
        for(i=0;i<5;++i)
        {
            ans[i].setBackground(orig);
        }

        //get a new word
        index= r.nextInt(wc-1)*2;
        word=(String)arr.get(index);
        northTF.setText("Please select the most appropiate meaning of the word : \"" + word.toUpperCase()+"\"");
        meaning=(String)arr.get(index +1);
        ansloc=r.nextInt(4);
        ans[ansloc].setText(meaning);
        for(i=0;i<5;++i)
        {
            if(i != ansloc)
            {
                index=r.nextInt(wc-1)*2 +1;
                ans[i].setText((String)arr.get(index));
            }
        }
        Status.setText("");
    }

public void closeIt()
    {
       clip.stop();
       System.exit(0);
    }
}

